package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Image;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.Set;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/11/6.
 */
@DAO
public interface ImageDao {
    @Insert
    int insert(Connection con, Image image) throws SQLException;

    @UpdateWith
    @From(Image.class)
    int updateSort(Connection con, String imageId, @Set int sort) throws SQLException;

    @UpdateWith
    @From(Image.class)
    int updateAllSort(Connection con, String resourceId, @Set int sort) throws SQLException;

    @SelectOne
    @Nullable
    Image query(Connection con, String imageId) throws SQLException;

    @SelectList
    List<Image> query(Connection con) throws SQLException;

    @SelectOne
    @Nullable
    Image queryOne(Connection con, String resourceId) throws SQLException;

    @SelectList
    List<Image> queryRes(Connection con, String resourceId) throws SQLException;

    @DeleteWith
    @From(Image.class)
    int deleteId(Connection con, String imageId) throws SQLException;

    @DeleteWith
    @From(Image.class)
    int deleteSrc(Connection con, String imageSrc) throws SQLException;

    @DeleteWith
    @From(Image.class)
    int deleteRes(Connection con, String resourceId) throws SQLException;

    @DeleteWith
    @From(Image.class)
    int deleteBySort(Connection con, String resourceId, int sort) throws SQLException;
}
